﻿namespace RadSchedulerApp.DatabaseProvider
{
    using Data;
    using System;
    using System.Collections.Generic;
    using System.Data.Entity.Migrations;
    using System.Linq;
    using System.Web;
    using Telerik.Web.UI;

    public class EfSchedulerProvider : SchedulerProviderBase
    {
        private RadSchedulerDbContext db = new RadSchedulerDbContext();

        public EfSchedulerProvider()
            : base()
        {
        }

        public override IEnumerable<Appointment> GetAppointments(ISchedulerInfo schedulerInfo)
        {
            var dbAppointments = this.db.Appointments.ToList();

            var appointmentsToReturn = new List<Appointment>();
            foreach (var dbAppointment in dbAppointments)
            {
                var appointment = new Appointment()
                {
                    ID = dbAppointment.ID,
                    Subject = dbAppointment.Subject,
                    Start = dbAppointment.Start,
                    End = dbAppointment.End
                };

                appointmentsToReturn.Add(appointment);
            }

            return appointmentsToReturn;
        }

        public override void Insert(ISchedulerInfo schedulerInfo, Appointment appointmentToInsert)
        {
            var newAppointment = new Models.Appointment
            {
                Subject = appointmentToInsert.Subject,
                Start = appointmentToInsert.Start,
                End = appointmentToInsert.End
            };

            this.db.Appointments.AddOrUpdate(newAppointment);
            this.db.SaveChanges();
        }

        public override void Update(ISchedulerInfo schedulerInfo, Appointment appointmentToUpdate)
        {
            var dbAppointment = new Models.Appointment
            {
                ID = (int)appointmentToUpdate.ID,
                Subject = appointmentToUpdate.Subject,
                Start = appointmentToUpdate.Start,
                End = appointmentToUpdate.End
            };

            this.db.Appointments.AddOrUpdate(this.db.Appointments.FirstOrDefault(a => a.ID == (int)appointmentToUpdate.ID), dbAppointment);
            this.db.SaveChanges();
        }

        public override void Delete(ISchedulerInfo schedulerInfo, Appointment appointmentToDelete)
        {
            var dbAppointment = this.db.Appointments.FirstOrDefault(a => a.ID == (int)appointmentToDelete.ID);

            this.db.Appointments.Remove(dbAppointment);
            this.db.SaveChanges();
        }

        public override IEnumerable<ResourceType> GetResourceTypes(RadScheduler owner)
        {
            var resoursesList = new List<ResourceType>();
            return resoursesList;
        }

        public override IEnumerable<Resource> GetResourcesByType(RadScheduler owner, string resourceType)
        {
            var resourcesList = new List<Resource>();
            return resourcesList;
        }
    }
}